if xsm_mechdamage == nil then
xsm_mechdamage = "loaded"

function applyDamage(damageRequest)
  local damage = 0
  if damageRequest.damageType == "Damage" or damageRequest.damageType == "IgnoresDef" then
    damage = damage + root.evalFunction2("protection", damageRequest.damage, self.protection)
  elseif damageRequest.damageType == "IgnoresDef" then
    damage = damage + damageRequest.damage
  else
    return {}
  end

  if damage > 0 then
    updateMechDamage(damage)
    storage.health = storage.health - damage
  end

  if vehicle.getParameter then
  return {{
    sourceEntityId = damageRequest.sourceEntityId,
    targetEntityId = entity.id(),
    position = mcontroller.position(),
    damageDealt = damage,
    hitType = "Hit",
    damageSourceKind = damageRequest.damageSourceKind,
    targetMaterialKind = self.materialKind,
    killed = storage.health <= 0
  }}
  else
  return {{
    sourceEntityId = damageRequest.sourceEntityId,
    targetEntityId = entity.id(),
    position = mcontroller.position(),
    damageDealt = damage,
    healthLost = damage,
    hitType = "Hit",
    damageSourceKind = damageRequest.damageSourceKind,
    targetMaterialKind = self.materialKind,
    killed = storage.health <= 0
  }}
  end

end

function updateMechDamage(damage)
local oldhp = storage.health / self.maxHealth
local newhp = (storage.health - damage) / self.maxHealth

  if oldhp > 0.8 and newhp <= 0.8 or oldhp > 0.6 and newhp <= 0.6
  or oldhp > 0.4 and newhp <= 0.4 or oldhp > 0.2 and newhp <= 0.2 then 
    updateMechDamageEffects(true) -- damageShards every 20%
  end

  if newhp <= 0 then -- blow chunks and EXPLOSIONS!
    local projectileConfig = {
      damageTeam = { type = "indiscriminate" },
      power = 1,
      onlyHitTerrain = true,
      timeToLive = 0,
      actionOnReap = {
        {
          action = "config",
          file =  "/projectiles/explosions/regularexplosion2/regularexplosion2.config"
        }
      }
    }
    world.spawnProjectile("invisibleprojectile", mcontroller.position(), 0, {0, 0}, false, projectileConfig)

    updateMechDamageEffects(true)
    animator.burstParticleEmitter("wreckage")

    vehicle.destroy()  -- your head asplode!
  end

end

function updateMechDamageEffects(dropShards)
if dropShards then animator.burstParticleEmitter("damageShards") return end
local curhealth = storage.health/self.maxHealth
  if curhealth > 0.5 or math.random() < curhealth then return end  -- undamaged, gtfo
  
  if curhealth <= 0.5 and math.random()/2 > curhealth then    -- 1 smoke
    animator.burstParticleEmitter("smoke1")    
  end
  if curhealth <= 0.4 and math.random()/2 > curhealth then    -- 1 smoke
    animator.burstParticleEmitter("smoke1")    
  end
  if curhealth <= 0.3 and math.random()/2 > curhealth then
    animator.burstParticleEmitter("smoke1")    
  end
  if curhealth <= 0.2 and math.random()/2 > curhealth then
   -- 1 smoke 1 fire
    animator.burstParticleEmitter("smoke2")    
    animator.burstParticleEmitter("fire1")
  end
  if curhealth <= 0.1 and math.random()/2 > curhealth then
    -- 2 fire
    animator.burstParticleEmitter("fire1")
    animator.burstParticleEmitter("fire2")
  end


end

end --xsm_mechdamage